;******************************************************************************
;* Programator: David Hankovec   DH-servis,vyvoj a vyroba elektroniky         *                   
;* http://home.tiscali.cz/dh_servis  ,  david.hankovec@tiscali.cz             *
;* Program    :	Hodiny DCF-77                                          	      *
;* Datum      : 19-08-2003 						      *
;* Versie     : V1.0   zkracena verze hodin na jeden displej, procesor 89C2051*
;******************************************************************************

$MOD52
$TITLE(BYTE SIGNED MULTIPLY)
$PAGEWIDTH(132)
$DEBUG
$OBJECT
$NOPAGING


org 00
AJMP start			;cold START

org 0bH			;INT od TIMERu 0
ljmp intt0

;****************************************************************************
;              Deklarace bitovych promennych                                *
;****************************************************************************
dcf77_puls      bit P3.2 	;vstup telegramu DCF
asynchronni	bit P3.1	;DCF neni synchronni / vystup na LED
vst_TL		bit P3.3	;vstup tlacitek

bseg at 30

DATA_BIT:         DBIT  1     ;
DCF_new:      	DBIT  1     ;signalizace, ze bit na vstupu z DCF je zmenen
SYNCHRON:         DBIT  1     ;synchronizace signalem DCF
ASYNC:            DBIT  1     ;0= DCF77-je zasynchronizovano
                              ;1= DCF77-neni synchronni
;----------------------------------------------------------------------------
ok_data:        	DBIT  1     ;priznak o.k. nactenych dat z DCF do RAM
RES_ANT:          DBIT  1     ;priznak rezervni anteny
Z_cas:          	DBIT  1     ;Zimni / letni cas
PARITY_ERROR:     DBIT  1     ;chyba parity
FULL_SECOND:      DBIT  1     ;1= dokoncena sekunda - cpl bitu po sekunde
FULL_MINUTE:      DBIT  1     ;1= dokoncena minuta (clr in hoofdpr)

tecka:		dbit 1		;priznak pro rozsviceni tecky u data
stisknuto:		dbit 1		;priznak ze tlacitko bylo stisknuto

po_resetu:		dbit 1
;****************************************************************************
;obsazeni portu PORT 3 jsou katody / 8 vyvodu
;PORT 2 a cast portu 0 jsou 

anoda_0_dis_1	bit P3.0
anoda_1_dis_1	bit P3.4
anoda_2_dis_1	bit P3.5
anoda_3_dis_1	bit P3.7

;**********************************************************************************
;Predvolba preteceni casovace po 20msec
;Predvolba pro casovac (65535 - 20008) pro 12 MHz krystal

predvolba         equ  0FFFFH - 12000 * 5/3 + 7 + 1  ; vypocet
                              ;12000 pri 12 MHz (delka )
			      ;Start hodnota Timer (= 20msec-Puls)

;****************************************************************************
;Mereni delky(cteni) DCF-77 pulsu: princip = 20 msec * konstanta ,20msec. je preteceni casovace
;rozmezi SS_MIN = 2 * 20msec=40 msec   ////     SS_MAX = 6 * 20msec=120msec
;nastaveni meznich casu trvani pulsu na 1 DCF puls:
 
SS_MIN          equ   02      ;minimalni delka impulsu pro impuls "0" - 2x20=40msec
SS_MAX          equ   06      ;maximalni delka impulsu pro impuls "0" - 6x20=120msec 
SL_MIN          equ   07      ;minimalni delka impulsu pro impuls "1" - 7x20=140msec 
SL_MAX          equ   14      ;minimalni delka impulsu pro impuls "1" - 14x20=280msec

;nastaveni meznich casu trvani mezery na 1 DCF puls:
;princip = 1000msec (50*20msec) - pausovy DCF-77 puls = vysl.

PS_MIN          equ   50 - SL_MAX   ;minimalni delka mezery pro impuls impuls "1" jako vyse,cas je 720msec
PS_MAX          equ   50 - SL_MIN   ;maximalni delka mezery pro impuls impuls "1"	860msec
PL_MIN          equ   50 - SS_MAX   ;minimalni delka mezery pro impuls impuls "0"	880msec	
PL_MAX          equ   50 - SS_MIN   ;minimalni delka mezery pro impuls impuls "0"	960msec

;testovani mezery po 59'sec,zde chybi impuls a mezera trva 2 sekundy
;princip = 2000msec (100*20msec) - nulovy DCF-77 puls

PSD_MIN         equ  100 - SL_MAX   ;minimalni delka mezery pro dvojitou pausu pro posledni puls "1" 1720msec
PSD_MAX         equ  100 - SL_MIN   ;maximalni delka mezery pro dvojitou pausu pro posledni puls "1" 1860msec
PLD_MIN         equ  100 - SS_MAX   ;minimalni delka mezery pro dvojitou pausu pro posledni puls "0" 1880msec	 
PLD_MAX         equ  100 - SS_MIN   ;maximalni delka mezery pro dvojitou pausu pro posledni puls "0" 1960msec

;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;Uprava konstant pro jine delky pulsu pri nefunkcnosti rutiny
;POPIS:Pouil jsem originln firemn prijmac DCF urcen k PC s vstupem telegramu DCF, ale procesor se nezasynchronizuje bud vubec, nebo obcas. 
;Po nekolika pokusech jsme doli k zveru, e bude asi nutno ponekud zmenit casovn na rozlien dlky impulsu v rutine. 
;Po zmene ji ve funguje jak m, ale neptejte se mne proc. Sm jsem s upravenm prijmacem dle svho nvodu oivil nekolik kusu hodin bez problmu,
; a ve zmnen prijmac jsem nemel v ruce a nebyla tedy monost "podvat" se osciloskopem na jeho vstup. 
;vice na tomto linku : http://home.tiscali.cz/dalsi/dalsi_hodiny.htm#hod_faq
;SS_MIN equ 03		;minimalni delka impulsu pro impuls "0" - 3x20=60msec 
;SS_MAX equ 07		;maximalni delka impulsu pro impuls "0" - 7x20=140msec 
;SL_MIN equ 08		;minimalni delka impulsu pro impuls "1" - 8x20=160msec
;SL_MAX equ 12		;minimalni delka impulsu pro impuls "1" - 12x20=240msec
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

;-----------------toto jsou konstanty,podle cisla se pozna pozadovana funkce k zobrazeni----------------------
fce_hodiny		equ 0H
fce_datum		equ 01H
fce_rok			equ 02H
fce_DvT			equ 03H

;****************************************************************************
;                           Definice promennych
;****************************************************************************
T0valuH         equ     high predvolba ;predvolba timer interrupt high
T0valuL         equ     low  predvolba ;predvolba timer interrupt low

typ_fce_dis	equ 31H	;zde je ulozen typ zobrazovane funkce dle displeje
		;fce 0=hodiny, 1=datum, 2=rok, 3=DvT

anoda		equ 35H	;cislo anody

dis_hi		equ 37H	;byty do kterych se nactou data,vymaskuji a poslou na displej
dis_lo		equ 38H

doba_tlacitka	equ 3DH	;cas pro soft osetreni zakmitu tlacitka
delka_tlacitka	equ	0FH	;zatim plny byte pro otestovani

tmp			equ	45H
;*************************************************************
BLOCK_PTR       equ   46h            ;ukazatel (pointer) pro pohyb v Data-Bloku
DCF_sekundy     equ   47h            ;pocitadlo sekund z DCF
COUNTER         equ   48h            ;inkrementovn po 20msec v preruseni od casovace
                                     ;nacita delku DCF-pulsu            
;***************************************************************************
;                     Interni Ram lokace pro real-time-hodiny promenne v BCD
;***************************************************************************
TIKKER         equ   49h            ;pocitadlo preteceni casovace po 20msec. ,toto pocitadlo pretece po 50x cili 1sec.
sekundy        equ   4ah            ;platny cas  - sekundy (bud v synchro s DCF nebo samostante)
minuty         equ   4bh            ;platny cas  - minuty
hodiny         equ   4ch            ;platny cas  - hodiny
den            equ   4dh            ;platny cas  - den
mesic          equ   4eh            ;platny cas  - mesic
rok            equ   4fh            ;platny cas  - rok
d_v_t          equ   50h            ;platny cas  - den v tydnu

;****************************************************************************
;            Data blok pro rozdelen kompletniho telegramu DCF na jednotlive casti
;****************************************************************************
                      dseg at 51h
DATA_BLOCK:       DS 2            ; zde ulozena DCF-77 data jako nahr.antena,zimni cas<
    DB_MIN:       DS 1            ; minuty informace (+ Parity-Bit P1)   <
    DB_HR:        DS 1            ; hodiny informace    (+ Parity-Bit P2)   <
    DB_DAY:       DS 1            ; den informatie                <
    DB_MON:       DS 1            ; den v tydnu/mesic informatie              <
    DB_YR:        DS 1            ; rok informace               <<<<<<<<<

;----------------------------------------------------------------------------
;****************************************************************************
;               H L A V N I   S M Y C K A
;****************************************************************************
                        cseg at 50h
;----------------------------------------------------------------------------
start:
;-------------------------------> inicializace
	LCALL zhasni
	LCALL logo
	LCALL zhasni

	MOV typ_fce_dis,#0  	;typ funkce po resetu (hodiny)
	

start_1:MOV SP,#5AH         ;nastaveni zasobniku na 5Ah
                              ;cas neni nastaven
      SETB RS0  		;druha registrova banka
	CALL  DCF_INIT          ;inicializace DCF-scan + preruseni timer

      MOV   rok,#0AAH          ;Obsazeni promennych real time clock po startu 
      MOV   mesic,#0AAH
      MOV   den,#0AAH
      MOV   hodiny,#0AAH
      MOV   minuty,#0AAH
      MOV   sekundy,#0AAH
	MOV   d_v_t,#08       


	
	CLR stisknuto
	MOV doba_tlacitka,#0	;nulovani predvolby pro osetreni tlacitka
	SETB asynchronni	;zhasni LED
	SETB po_resetu		;nastavi se priznak a dokud neni vynulovan,zobrazuji se pomlcky.Nuluje se po prvnim
					;uspesnem nacteni casu z DCF
zac:	MOV anoda,#0H		;pocatecni anoda
		

opak:	MOV A,typ_fce_dis	;v Acc je pozadovana funkce na displej
	LCALL obsazeni_disp
	LCALL maskuj		;data vymaskovana,poslana na port i s desetinnou teckou
	LCALL anody		;sepnuti spravne anody ,po vykonani cislo sviti		

; disp status bity
status: 
	mov     c,async	
      	mov     asynchronni,c
	
	LCALL cekej_10
	INC anoda			;zvys anodu
	MOV A,anoda			;testuj anodu
	CJNE A,#4,opak
	SJMP zac			;posledni anoda,posledni displej, navrat na zacatek


cekej_10:	MOV r3,#0D0H
cekej_11:	MOV r4,#01H
		DJNZ R4,$
		DJNZ R3,cekej_11
RET



;*******************SUBRUTINA OBSAZENI DISPLEJE*****************
;V Acc je cislo funkce pozadovane k zobrazeni na  displej
;vraci v dis_ho a dis_lo BCD cislo. Nastavuje parametry desetinne tecky
;**************************************************************** 

obsazeni_disp:	CJNE A,#fce_hodiny,pokr_01	;je pozadavek hodin
		MOV dis_hi,hodiny		;provedeno nacteni hodin a minut
		MOV dis_lo,minuty
		SJMP navrat_01
	

pokr_01:	CJNE A,#fce_datum,pokr_02	;je pozadavek na zobrazovani data
		MOV dis_hi,den			;nacti data	
		MOV dis_lo,mesic		;nacti data
		SETB tecka			;nastav priznak tecky
		SJMP navrat_01

pokr_02:	CJNE A,#fce_rok,pokr_03	;pozadavek na zobrazovani roku
		MOV dis_hi,#20H
		MOV dis_lo,rok
		SJMP navrat_01

pokr_03:	MOV dis_hi,#0BBH	;pozadavek na zobrazovani dne v tydnu / prvni 2 cisla zhasni
		MOV dis_lo,d_v_t

navrat_01:	RET

;*******************SUBRUTINA VYMASKOVANI DISPLEJE NA ZOBRAZENI 1 CIFRY***************** 
 
;***********************PRVNI ANODA**************
maskuj: 	MOV DPTR,#tabznak	;nacti prvni adresu tabulky znaku
		MOV A,anoda		;nacti anodu
		JNZ pokr_04		;prvni anoda je 0, ponech vyssi nibble z vyssiho byte displeje
			
		MOV A,typ_fce_dis	;nacti co se bude zobrazovat
		CJNE A,#fce_hodiny,pokr_22
		MOV A,dis_hi
		ANL A,#0F0H
		SWAP A
		MOVC A,@A+DPTR		;cti reprezentaci cisla v tabulce
		SJMP navrat_02
		
pokr_22:	MOV A,dis_hi	;pro nezobrazeni bezvyznamnych nul krome hodin
		ANL A,#0F0H
		JZ pokr_23		;je prvni cislo nula?
		SWAP A
		MOVC A,@A+DPTR		;cti reprezentaci cisla v tabulce
		SJMP navrat_02

pokr_23:	MOV A,#0H
		SJMP navrat_02


;***********************DRUHA ANODA**************
pokr_04:	CJNE A,#1,pokr_05
		MOV A,dis_hi
		ANL A,#0FH
		MOVC A,@A+DPTR			;cti reprezentaci cisla v tabulce
		MOV R2,A			;schovej hodnotu
		MOV A,typ_fce_dis		;v Acc je zpet pozadovana funkce na displej
		CJNE A,#fce_hodiny,pokr_07	;cti pozadovanou k zobrazeni
		JB FULL_SECOND,navrat_03 ;jsou to fce_hodiny,tecka neni,ven
		MOV A,R2			;obnov data
		ADD A,#128			;pricti tecku
		SJMP navrat_02		;ven (posli na port)
pokr_07:	CJNE A,#fce_datum,navrat_03	;jde o fce_datum?
		MOV A,R2			;obnov data
		ADD A,#128			;rozsvit tecku trvale
		SJMP navrat_02

;***********************TRETI ANODA**************
pokr_05:	CJNE A,#2,pokr_06
		MOV A,typ_fce_dis		;v Acc je zpet pozadovana funkce na displej
		CJNE A,#fce_DvT,pokr_20	;je to den v tydnu?
		MOV DPTR,#dvt_tab		;ano nacti jimou tabulku
		MOV A,dis_lo		;cti hodnotu
		RL A				;nasob x2 (dny jsou po dvou pismenech	
		SUBB A,#1H			;odecti 1 pro prechod na prvni pismeno	
		MOVC A,@A+DPTR		;nacti reprezentaci
		MOV DPTR,#tabznak		;vrat DPTR na cisla
		SJMP navrat_02

pokr_20:	MOV DPTR,#tabznak
		MOV A,dis_lo
		ANL A,#0F0H
		JNZ pokr_26			;je to nula?
		MOV R2,A			;je to nula,uloz a testuj zda jde o fce_datum
		MOV A,typ_fce_dis		;v Acc je zpet pozadovana funkce na displej
		CJNE A,#fce_datum,pokr_25	;pokud nejde o fce_datum,cti zpet hodnotu a vrat se beze zmeny
		MOV A,#0B0H			;zadej prazdny znak - bacha u pokr_26 se provede swap proto neni 0B ale 0B0!!!
		SJMP pokr_26
pokr_25:	MOV A,R2 
pokr_26:	SWAP A
		MOVC A,@A+DPTR		;cti reprezentaci cisla v tabulce
		SJMP navrat_02
	
;***********************CTVRTA ANODA**************
pokr_06:	MOV A,typ_fce_dis		;v Acc je zpet pozadovana funkce na displej
		CJNE A,#fce_DvT,pokr_21	;je to den?
		MOV DPTR,#dvt_tab		;ano nacti jimou tabulku
		MOV A,dis_lo		;cti hodnotu
		RL A				;nasob x2 (dny jsou po dvou pismenech
		MOVC A,@A+DPTR		;nacti reprezentaci

;********************************BACHA, tohle v originale nebylo, ale pridal jsem to tam ********************
		MOV DPTR,#tabznak		;vrat DPTR na cisla
;************************************************************************************************************

		SJMP navrat_02

pokr_21:	MOV A,dis_lo
		ANL A,#0FH
		MOVC A,@A+DPTR		;cti reprezentaci cisla v tabulce
		MOV R2,A			;schovej hodnotu
		MOV A,typ_fce_dis		;v Acc je zpet pozadovana funkce na displej
		CJNE A,#fce_datum,navrat_03	;jde o fce_datum?
		MOV A,R2			;ano,obnov data
		ADD A,#128
		SJMP navrat_02

navrat_03:	MOV A,R2			;obnov data pro katody
navrat_02:	JNB po_resetu,platna_data	;po resetu kdy jeste nejsou k dispozici platna data zobrazuj pomlcky a blikej teckou
		MOV A,#64				;rozsvit pomlcku
		JB FULL_SECOND,platna_data	;testuj blikani tecky
		MOV A,#0				;a blikej pomlckama
platna_data:	CPL A				;proved negaci pro spolecnou anodu
		MOV tmp,A			;zatim to schovej
		RET

;nezapomen do preruseni od DCF zadat zpet adresu do DPTR na tabulku znaku/schovat DPH a DPL 


;--------------------------PRVNI DISPLEJ--------------------------------------------------------

anody:		MOV A,anoda
		JNZ pokr_10
		LCALL zhasni
		MOV P1,tmp			;vyber data katod
		CLR 	anoda_0_dis_1	;sepni anodu
		SJMP navrat_05
	
pokr_10:	CJNE A,#1,pokr_11
		LCALL zhasni
		MOV P1,tmp			;vyber data katod
		CLR anoda_1_dis_1
		SJMP navrat_05

pokr_11:	CJNE A,#2,pokr_12
		LCALL zhasni
		MOV P1,tmp			;vyber data katod
		CLR anoda_2_dis_1
		SJMP navrat_05


pokr_12:	;posledni anoda se netestuje
		LCALL zhasni
		MOV P1,tmp			;vyber data katod
		CLR anoda_3_dis_1
		
		JB vst_TL,pokr_35 		;je stisknuto tlacitko u tretiho displeje? H=neni
		SETB stisknuto			;tlacitko stisknuto, nastav priznak 
		MOV A,doba_tlacitka
		CJNE A,#delka_tlacitka,pokr_tl	;pokud je jiz dosazeno doby stisknuti tlacitka, jiz nezvysuj
		SJMP navrat_05
pokr_tl:	INC doba_tlacitka
		SJMP navrat_05


pokr_35:	JNB stisknuto,navrat_05		;tlacitko uvolneno
		CLR stisknuto
		MOV A,doba_tlacitka		;nacti dosazenou dobu
		MOV doba_tlacitka,#0H		;nuluj dobu stisknuti tlacitka
		CJNE A,#delka_tlacitka,navrat_05  ;pokud doba nedosazena, nedelej nic a vystup
		INC	typ_fce_dis		;prechod na dalsi zobrazovanou funkci
		MOV A,typ_fce_dis
		CJNE A,#fce_DvT+1,navrat_05		;pokud to neni posledni funkce+1, pak se vrat
		MOV typ_fce_dis,#0		;nacti prvni data (zobrazeni hodin)
		
navrat_05:	RET


;----------------------------------------------------------------------------------
;zhasne cislo/pro zjednoduseni se zhasinaji vsechny najednou (i "zhasnute")
zhasni:		SETB anoda_0_dis_1
		SETB anoda_1_dis_1
		SETB anoda_2_dis_1
		SETB anoda_3_dis_1
		RET		

;------------------------vypise na displej postupne logo DAVI----------------------
logo:		MOV R2,#0FFH
		MOV R3,#0D0H
		MOV R4,#0C0H
		MOV R5,#0FFH
		LCALL pausa
logo_1:		MOV A,#94
		LCALL na_port
		CLR anoda_0_dis_1		;sviti D
		LCALL pausa
		SETB anoda_0_dis_1
		DJNZ R2,logo_1
		MOV R2,#1H
		MOV A,#119
		LCALL na_port
		CLR anoda_1_dis_1	
		LCALL pausa
		SETB anoda_1_dis_1
		DJNZ R3,logo_1
		MOV R2,#1H
		MOV R3,#1H
		MOV A,#28
		LCALL na_port
		CLR anoda_2_dis_1
		LCALL pausa
		SETB anoda_2_dis_1
		DJNZ R4,logo_1
		MOV R4,#01H
		MOV A,#6
		LCALL na_port
		CLR anoda_3_dis_1
		LCALL pausa
		SETB anoda_3_dis_1
		DJNZ R5,logo_1
		RET

na_port:	CPL A
		MOV P1,A
		RET
pausa:		mov r0,#0A0H
pausa_1:	MOV r1,#01H
		DJNZ R1,$
		DJNZ R0,pausa_1
	RET

;********preruseni od casovace************************

INTT0:  CLR RS0		;prvni registrova banka
	  mov     TL0,#T0valuL     ;nacti predvolbu
        mov     TH0,#T0valuH     ;nacti predvolbu
        PUSH    PSW
        PUSH    ACC
        PUSH    DPH
	  PUSH	DPL
	  djnz    tikker,read_dcf
        mov     tikker,#50		;software citac preruseni,po 20msec je incrementovan
        setb    full_second		;50x20 msec = 1 sec.
        call    increment
read_dcf:MOV A,tikker		;po 200 msec. nuluj priznak
	CJNE A,#5,dalsi
	CLR full_second
dalsi:call    scan_dcf77
exit_int:
	pop DPL
	pop DPH
        pop     acc
        pop     psw

	SETB RS0		;druha registrova banka
        reti
;****************************************************************************
;                S u b r u t i n a  D C F 7 7 _  I N I T                  *
; ---------------------------------------------------------------------------
; Inicializace pro cteni DCF-77
; Nastaveni casovace pro vyvolani INT po 20 msec.

DCF_INIT:
         mov     DCF_sekundy,#0     ;nuluj pocitadlo sekund (pulsu) od  DCF_sekundy

;---------------------------------->inicializace timeru
T0INIT:  MOV    TH0,#T0valuH        ;16 bit predvolba v modu 1
         MOV    TL0,#T0valuL
         MOV    TMOD,#11H           ;casovac 0 v modu 1
         SETB   TR0        		;start timer
         SETB   ET0              ;timer 0 INTERUPT ON
         SETB   EA              ;interupts on
;----------------------------------> set/clr  priznaky
         CLR     SYNCHRON           ;nesynchronizovano s DCF
         CLR     ok_data          ;priznak platnych dat v RAM z DCF pro moznost update
         CLR     PARITY_ERROR       ;Neplatna parita
         SETB    ASYNC              ;nesynchronizovano
         CLR     FULL_MINUTE        ;
         CLR     FULL_SECOND        ;
ret

;****************************************************************************
;         S u b r o u t i n e        S C A N _ D C F 7 7                    *
;****************************************************************************                                                                            |
; Rutina scanuje signal z DCF-77 a zapisuje datove bity postupn do bloku   *
; ("DATA_BLOCK").                                                           *
; --------------- !! Pozor DCF-77 signal je aktivni v nule (negovany) !!-   *
; Ve dvojite pause (59'sec) jsou hodiny synchronizovany s DCF77-signalem.   *
; Pokud jsou vsechna data spravne nactena v bloku, jdi na "UPDATE_TIME".    *
;Tam se zkontroluje parita a pokud je bez chyby nasleduje prepsani dat      *                                           
;----------------------------------------------------------------------------
SCAN_DCF77:
           MOV     C,dcf77_puls      ;prekopirovani urovne ze vstupu
           cpl     c                 ;negovani do spravne urovne
                                     ;na port jde aktivni puls 0, zde potrebujeme 1
           INC     COUNTER           ;citac delky impulsu
           JC      HIGH_NOW
           JNB     DCF_new,TO_THE_END    ;0 ---> 0 : trva uroven nula od minule - nic se nezmenilo,pausa trva
           SJMP    jedna_na_nula            ;1 ---> 0 : nastal prechod z 1 do 0, skok na obsluznou rutinu
HIGH_NOW:  JNB     DCF_new,nula_na_jedna ;0 ---> 1 : nastal prechod z 0 do 1, skok na obsluznou rutinu
TO_THE_END:LJMP    DCF77_RET                ;1 ---> 1 : trva uroven 1 od minule,nic se nezmenilo uroven trva(0 ---> 0)

nula_na_jedna:    ;<----Konec mezery,zacatek pulsu,nova sekunda: ( 0 ---> 1 )
          MOV     DCF_new,C        ;prekopirovani do priznaku, kterym se testuje, zda se nezmenil puls od minule
          MOV     A,COUNTER		;nacti delku pausy
          CLR     C
          SUBB    A,#PS_MIN           ;kontrola minimalni delky pausy
          JC      FAILURE             ;pausa nema minimalni delku - ven
	  SUBB    A,#PS_MAX-PS_MIN+1  ;test pausy pro pausu pro predchozi impuls "1"
          JC      SHORT_PAUSE         ;kratka pausa na data-impuls ( 0/1 )
          SUBB    A,#PL_MIN-PS_MAX-1  ;dvojita pausa na data-impuls ( 0/1 )
          JC      FAILURE
          SUBB    A,#PL_MAX-PL_MIN+1
          JC      LONG_PAUSE
          SUBB    A,#PSD_MIN-PL_MAX-1
          JC      FAILURE
          SUBB    A,#PSD_MAX-PSD_MIN+1
          JC      SHORT_DPAUSE
          SUBB    A,#PLD_MIN-PSD_MAX-1
          JC      FAILURE
          SUBB    A,#PLD_MAX-PLD_MIN+1
          JC      LONG_DPAUSE
          SJMP    FAILURE

LONG_PAUSE:
          SJMP    NEW_PULSE
SHORT_PAUSE:
          JNB     DATA_BIT,FAILURE    ;Signal-Pausa po "1"
          SJMP    NEW_PULSE

SHORT_DPAUSE:
        
          JB      ASYNC,INI_CYCLE     ;Pokud neni zasynchronizovano,inicializace
          JNB     DATA_BIT,FAILURE    ;dvojita pausa na hodnotu "1" na konci tlg.
          SJMP    CHECK_58
LONG_DPAUSE:
          JB      ASYNC,INI_CYCLE     ;Pokud neni zasynchronizovano,inicializace
          JB      DATA_BIT,FAILURE    ;dvojita pausa na hodnotu  "0" na konci tlg.
CHECK_58:
          mov     r1,DCF_sekundy
          CJNE    r1,#58,FAILURE      ;Jde o 58. Sekundu ??, ne chyba,ano pokracuj

	      CALL    UPDATE_TIME         ;<--- volani update dat, prepise aktualni data daty z DCF
          SETB    FULL_MINUTE         
          SETB    SYNCHRON		;nastav priznak synchronniho DCF a hodin
          SETB    ok_data           ;nastav priznak plneho bloku RAM, pokud je chyba v parite,stejne je nastaven                                 

 MOV     A,DATA_BLOCK+1
          MOV     C,ACC.5             ;= letni cas
          MOV     Z_cas, C           ;                                 
          MOV     C, ACC.3            ;= rezervni antena
          MOV     RES_ANT, C          ;

INI_CYCLE:MOV     DCF_sekundy,#-1     ;Pripraveno pro dalsi cyklus (minutu)
          CLR     ASYNC               ;nuluj priznak asynchronni

NEW_PULSE:INC     DCF_sekundy         ;novy platny impuls,zvys pocitadlo sekund od DCF
 
         SJMP    DCF77_END
;----------------------------------------------------------------------------
FAILURE:  CLR     SYNCHRON            ;vstupni impuls od DCF je mimo toleranci
          SETB    ASYNC		;nastav priznak asynchronni, nuluj synchronni
          SJMP    DCF77_END
;----------------------------------------------------------------------------

jedna_na_nula:    ;<-------Dekodovani impulsu podle delky:( 1 --> 0 )
          MOV     DCF_new,C        ;aktualizuj
          MOV     A,COUNTER
          CLR     C
          SUBB    A,#SS_MIN           ;Odecteni minimalniho trvani pulsu
          JC      FAILURE             ;pokud byl kratsi, neni platny 
          SUBB    A,#SS_MAX-SS_MIN+1  ;2 moznosti:
          JC      SHORT_PULSE         ;0.1 sec Impuls  =  "0"
          SUBB    A,#SL_MIN-SS_MAX-1  ;0.2 sec Impuls  =  "1"
          JC      FAILURE
          SUBB    A,#SL_MAX-SL_MIN+1
          JNC     FAILURE

LONG_PULSE:SETB   DATA_BIT            ;Hodnota bitu je '1'
          SJMP    BIT_KNOWN
SHORT_PULSE:CLR   DATA_BIT            ;Hodnota bitu je '0'

BIT_KNOWN:

          JB      ASYNC,DCF77_END     ;Neni synchro: VEN!
          mov     r1,DCF_sekundy
          CJNE    r1,#00,ADD?         ;Je ukoncen cyklus ??
          JB      DATA_BIT,FAILURE    ;Pokud neni ukoncen a data bit ma hodnotu 1 je to chyba
          SJMP    DCF77_END
ADD?:
          mov     r1,DCF_sekundy
          CJNE    r1,#04,ADD_IN?      
          MOV     block_ptr,#DATA_BLOCK
          mov     r0,block_ptr
          MOV     @r0,#80H            
          SJMP    SHIFT_IN
ADD_IN?:  JC      DCF77_END           
          mov     r1,DCF_sekundy
          CJNE    r1,#20,PAR?         
          JNB     DATA_BIT,FAILURE    
          SJMP    DCF77_END
PAR?:     mov     r1,DCF_sekundy
          CJNE    r1,#58,SHIFT_IN     
          SJMP    DCF77_END           
SHIFT_IN:
          MOV     C,DATA_BIT          
          mov     r0,block_ptr        
          XCH     A,@r0               
          RRC     A                   
          XCH     A,@r0
          JNC     DCF77_END          
	      MOV     A,#10000000B        ;mezni hodnota 8-bit hodnota
HR?:      mov     r1,DCF_sekundy
          CJNE    r1,#28,den?         
          RR      A                   ;mezni hodnota 7-bit hodnota
den?:     CJNE    r1,#35,NEXT_ENTRY
          RR      A
	    RR      A                   ;mezni hodnota 6-bit hodnota
NEXT_ENTRY:
          INC     block_ptr			;incrementuj ukazatel
          mov     r0,block_ptr		
          MOV     @r0,A              ;prepis udaj novou hodnotou

DCF77_END:MOV     COUNTER,#00        ;nuluj citac obehu
          

DCF77_RET:
          RET                        ;navrat
;****************************************************************************
;  S u b r o u t i n e        U P D A T E _ T I M E                         *
;****************************************************************************                                                                            
;  Rutina dekoduje "DATA_BLOCK" z casovych registru.
;  Vysledek je po kontrole parity zapsan do odpovidajicich byte.
; Pokud se vyskytne jedna chyba, nic neni prepsano a zustava puvodni udaj!!         
;----------------------------------------------------------------------------

UPDATE_TIME:      ;<---------------- nejprve kontroluje paritu

          MOV     R3,#05              ;casovy format= 5 Byte z "DATA_BLOCK"
          MOV     BLOCK_PTR,#DATA_BLOCK + 1
          MOV     B,#00               ;B: Parity-Bity 
GET_PAR:  INC     BLOCK_PTR
          mov     r0,block_ptr
          MOV     A,@r0
          MOV     C,PSW.0             
          XCH     A,B
          RLC     A
          XCH     A,B                 ;<---- porovnani
          DJNZ    R3,GET_PAR
          MOV     A,B
          MOV     C,DATA_BIT          
          RLC     A
          JNB     PSW.0,DATA_TO_REGS  ;Totale Parity je OK
          SETB    PARITY_ERROR        ;                            
          SJMP    UPDATE_END          ;Parity-chyba -> VEN!

DATA_TO_REGS:     ;<------------------;parita O.K. prepis data.

	CLR po_resetu			;nacteni o.k. nepreskakuj zobrazeni(pomlcky po resetu)
  	 MOV     A,DB_MIN            ;minutova-informace
          CLR     ACC.7               ;Paritni-Bit pryc
          MOV     minuty,A

          MOV     A,DB_HR             ;hodiny informace
	      RR      A                   ;7-data-bit hodnota
	      CLR     ACC.6               ;Paritni-Bit pryc
           MOV     hodiny,A

          MOV     A,DB_DAY            ;datum den-informace
          RR      A
	      RR      A                   ;6-data-bit hodnota
          MOV     den,A

          MOV     A,DB_MON            ;den v tydnu/mesic informace
          MOV     B,#00001000B        ;rozdel: den v tydnu = 3 Bit
          DIV     AB                  ;A= mesic    B=d_v_t
          MOV     d_v_t,B
          MOV     mesic,A

          MOV     A,DB_YR             ;rok-informace
          MOV     rok,A

          MOV     sekundy,#99H        ;<-- sekundy=0 na volle inleescyclus.
          MOV     tikker,#04          ;real time z DCF77-aktualizuj.
                                      ;Timer-citac = 40 msec.
          CLR     PARITY_ERROR        ;zadna chybna parita

UPDATE_END: RET

;****************************************************************************
;            S u b r u t i n a        I N C R E M E N T                   *   
;****************************************************************************
;   Rutina realneho casu sec:min:hr den/DvT:mesic:rok )
;   Kontroluje a spravne uklada pocet dni v mesici (30,31) a navic kontroluje
;   prestupny rok a upravuje unor. Bezi samostatne i bez synchro z DCF
;----------------------------------------------------------------------------

INCREMENT:
	MOV A,sekundy		;nacti do ACC byte vteriny
	ADD A,#1H			;pricti 1
	DA A				;korekce
	MOV sekundy,A		;uloz vteriny zpet
	XRL A,#60H			;je dosazeno minuty ?	
	JNZ INCR_END		;neni pak navrat z preruseni
	MOV sekundy,A		;nuluj byte vteriny
	SETB    FULL_MINUTE
	MOV A,minuty		;nacti do ACC obsah byte minuty
	ADD A,#1			;pricti k ACC 1
	DA A				;korekce
	MOV minuty,A		;uloz minuty zpet
	XRL A,#60H			;je dosazeno hodiny ?
	JNZ INCR_END			;neni pak navrat z preruseni pres test casu z tabulky
	MOV minuty,A		;nuluj byte minuty
	MOV A,hodiny		;nacti do ACC obsah byte hodiny
	ADD A,#1			;pricti k ACC 1
	DA A				;korekce
	MOV hodiny,A		;uloz zpet hodiny
	XRL A,#24H			;je dosazeno 24 hodin ?
	JNZ INCR_END			;neni pak navrat z preruseni pres test casu z tabulky
	MOV hodiny,A		;nuluj byte hodiny

          INC     d_v_t
          mov     r7,d_v_t
          CJNE    r7,#08,NEXT_DAY
	      MOV     d_v_t,#01         

NEXT_DAY: 
MOV A,den		;nacti do ACC obsah byte mesic
	ADD A,#1			;pricti k ACC 1
	DA A				;korekce
	MOV den,A		;uloz zpet mesic
      MOV     DPTR,#DAYS_PER_MONTH-1
      MOV     A,mesic             ;mesic(1...12)+TAB-1 = nastaveni
	MOVC    A,@A+DPTR           ;delka mesice / pocet dni
      MOV     r5,mesic
      CJNE    r5,#02,COMP_LEN
      MOV     B,A                 ;<-- mesic = unor
      MOV     A,rok		;cti rok
          
	;tady prevest rok z BCD na binarni
	LCALL BCD_2_HEX
	ANL     A,#00000011B			;zjisti zda je prestupny
      JNZ     NORMAL              ;pokud neni nula / neni prestupny
      MOV A,B		;je prestupny unor= 29 dni / zvys pocet dni z tabulky o jeden / pro unor 
	ADD A,#1
	DA A
	MOV B,A

NORMAL:   MOV     A,B                 ;neni prestupny, vrat pocet dni v mesici zpet
COMP_LEN: MOV     B,den			;cti aktualni den
          CJNE    A,B,INCR_END	;porovnej a pri preteceni nuluj
          MOV     den,#01H
        
	MOV A,mesic		;nacti do ACC obsah byte mesic
	ADD A,#1			;pricti k ACC 1
	DA A				;korekce
	MOV mesic,A		;uloz zpet mesic
	XRL A,#13H			;je dosazeno 12 mesicu ?
	JNZ INCR_END			;neni pak navrat 
	MOV mesic,#01H		;byte mesic / leden

	MOV A,rok		;nacti do ACC obsah byte roky
	ADD A,#1			;pricti k ACC 1
	DA A				;korekce
	MOV rok,A		;uloz zpet roky
	XRL A,#100H			;je dosazeno 100 let ?
	JNZ INCR_END			;neni pak navrat 
	MOV rok,A		;nuluj byte roky
INCR_END: RET
;--------------------------------------------------------------------------------
BCD_2_HEX:
		MOV R7,B			
		PUSH	ACC			
		ANL	A,#0f0h		
		SWAP	A			
		MOV	B,#10			
		MUL	AB			
		MOV	B,A			
		POP	ACC			
		ANL	A,#00fh		
		ADD	A,B			
		MOV B,R7			
		RET
;------------------------------------------------------------------------------

DAYS_PER_MONTH:                       ;Delka mesice - pocet dni,mesice jsou v BCD,ale vyhledavani v tabukce je hexa
          DB 32h                      ;cili mesic napr. 12BCD odpovida 18h a na te pozici je odpovidajici pocet dni
          DB 29h                       
          DB 32h
          DB 31h,32h,31h
          DB 32h,32h,31h,0,0,0,0,0,0,32h,31h,32h
         
;-------------Tabulky---------------
	version:	DB 0,28,64,134,79,0,0,0,0,0,0,0,0,0,0
;verse 1.0				^--toto cislo je souctem cifry a reprezentace desetinne tecky kvuli jejimu
;rozsviceni (aby se rozsvitila az s cislem a ne napred)

	tabznak:        DB 63,6,91,79,102,109,125,7,127,111,64,0
;reprezentace cisel       0,1,2 , 3, 4 , 5 , 6 ,7 ,8 , 9 , -,prazdny znak

dvt_tab:	DB 0,115,92,62,120,109,120,57,120,115,119,109,92,84,121,
;reprezentace dneP  o , U  t ,  S  t , C  t , P   A ,  S  o,n  E  , 

 END
